/*
 * This file is a part of EpnTAPClient.
 * This program aims to provide EPN-TAP support for software clients, like CASSIS spectrum analyzer.
 * See draft specifications: https://voparis-confluence.obspm.fr/pages/viewpage.action?pageId=559861
 * Copyright (C) 2016 Institut de Recherche en Astrophysique et Planétologie.
 *
 * This program is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or (at your option) any later
 * version. This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details. You should have received a copy of
 * the GNU General Public License along with this program. If not, see
 * <http://www.gnu.org/licenses/>.
 */

package eu.omp.irap.vespa.epntapclient.gui.mainpanel;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSplitPane;

import eu.omp.irap.vespa.epntapclient.gui.requestpanel.RequestPanelView;
import eu.omp.irap.vespa.epntapclient.gui.resultpanel.ResultsPanelView;
import eu.omp.irap.vespa.epntapclient.gui.servicespanel.ServicesPanelView;
import eu.omp.irap.vespa.epntapclient.gui.statusbarpanel.StatusBarPanelView;

/**
 * The main view of the application, which manage all the other views.
 *
 * @author N. Jourdane
 */
public class MainPanelView extends JPanel {

	/** The default serial version UID. */
	private static final long serialVersionUID = 1L;

	/** The JPanel where the user build the query. */
	private RequestPanelView requestPanel;

	/** The JPanel where the VOTable results is displayed. */
	private ResultsPanelView resultPanel;

	/** The JPanel where the list of services is displayed. */
	private ServicesPanelView servicesPanel;

	/** The JPanel where the list of services is displayed. */
	private StatusBarPanelView statusBarPanel;


	/**
	 * The main view constructor, which create all the panels.
	 *
	 * @param mainPanelCtrl The controller of the main panel.
	 */

	public MainPanelView(MainPanelCtrl mainPanelCtrl) {
		servicesPanel = mainPanelCtrl.getServicesCtrl().getView();
		resultPanel = mainPanelCtrl.getResultsCtrl().getView();
		requestPanel = mainPanelCtrl.getRequestCtrl().getView();
		statusBarPanel = new StatusBarPanelView();
		buildMainView();
	}

	/**
	 * Display an error message. Usually used each time an error happens.
	 *
	 * @param title The title of the error.
	 * @param message The message of the error.
	 */
	public void displayError(String title, String message) {
		JOptionPane.showMessageDialog(this, message, title, JOptionPane.ERROR_MESSAGE);
	}

	/**
	 * @return The JPanel containing the GUI elements to build the query.
	 */
	public RequestPanelView getRequestPanel() {
		return requestPanel;
	}

	/**
	 * @return The JPanel where the VOTable result is displayed.
	 */
	public ResultsPanelView getResultsPanel() {
		return resultPanel;
	}

	/**
	 * @return The JPanel where the list of services is displayed.
	 */
	public ServicesPanelView getServicesPanel() {
		return servicesPanel;
	}

	/**
	 * @return The view of the status bar panel.
	 */
	public StatusBarPanelView getStatusBarPanelView() {
		return statusBarPanel;
	}

	/**
	 * Build the panel and add GUI elements on it.
	 */
	private void buildMainView() {
		setLayout(new BorderLayout());

		JSplitPane northPanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, servicesPanel,
				requestPanel);
		JSplitPane mainPanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT, northPanel, resultPanel);
		add(mainPanel, BorderLayout.CENTER);
		add(statusBarPanel, BorderLayout.SOUTH);

		setSizes();
		revalidate();
	}

	/**
	 * Set the preferred and minimum size of panels.
	 */
	private void setSizes() {
		servicesPanel.setPreferredSize(
				new Dimension(GUIDim.LEFT_PANEL_WIDTH, GUIDim.TOP_PANEL_HEIGHT));
		servicesPanel.setMinimumSize(
				new Dimension(GUIDim.LEFT_PANEL_MIN_WIDTH, GUIDim.TOP_PANEL_MIN_HEIGHT));

		requestPanel.setPreferredSize(
				new Dimension(GUIDim.RIGHT_PANEL_WIDTH, GUIDim.TOP_PANEL_HEIGHT));
		requestPanel.setMinimumSize(
				new Dimension(GUIDim.RIGHT_PANEL_MIN_WIDTH, GUIDim.TOP_PANEL_MIN_HEIGHT));

		resultPanel.setPreferredSize(
				new Dimension(GUIDim.LEFT_PANEL_MIN_WIDTH + GUIDim.RIGHT_PANEL_MIN_WIDTH,
						GUIDim.BOTTOM_PANEL_HEIGHT));
		resultPanel.setMinimumSize(
				new Dimension(GUIDim.LEFT_PANEL_MIN_WIDTH + GUIDim.RIGHT_PANEL_MIN_WIDTH,
						GUIDim.BOTTOM_PANEL_MIN_HEIGHT));
	}

}
